#!/usr/bin/env ruby19

# The solver to the quiz from PragPub #8 (2010.02).
#
# Run it like:
#
# % ./2010-02.rb < eliza.txt

$DEBUG=nil

class LSCode
  def map_make(arr)
    r = {}
    ('a'..'z').to_a.each_with_index { |v, i| r[v] = arr[i] }
    return r
  end
  private :map_make

  attr_reader :m
  def initialize()
    a = [?k, ?v, ?g, ?j, ?z, ?m, ?a, ?u, ?w, ?p, ?y, ?x, ?n,
         ?i, ?s, ?q, ?l, ?d, ?o, ?c, ?t, ?e, ?r, ?f, ?b, ?h]
    @m = map_make(a)
  end

  def dec(s)
    subst = ->i {
      revert = nil
      if /[[:upper:]]/ =~ i
        revert = true
        i.downcase!
      end
      r = @m.key?(i) ? @m[i] : i
      revert ? r.upcase : r
    }
    
    r = ""
    s.each_char { |i| r << subst.call(i) }
    return r
  end

end

code = LSCode.new()
puts code.m() if $DEBUG
while line = STDIN.gets()
  puts code.dec(line)
end
